#
# Stupid Tar Interface
#
# (C) Copyright 2000,2001 The Internet (Aust) Pty Ltd
# ACN: 082 081 472  ABN: 83 082 081 472
# All Rights Reserved
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# Author: Andrew Milton <akm@theinternet.com.au>

# This is a f*cking mess, this is what I get for allocating 30 mins to do it
# in

import os
import string
import errno
from gzip import GzipFile

TAR_BLOCKSIZE=512

REGTYPE='0'   # Regular File
AREGTYPE='\0' # Regular File
LNKTYPE='1'   # Link
SYMTYPE='2'   # Reserved?
CHRTYPE='3'   # Character Special
BLKTYPE='4'   # Block Special
DIRTYPE='5'   # Directory
FIFOTYPE='6'  # FIFO Special
CONTTYPE='7'  # Reserved

class TarOps:
	data=''
	def isDirectory(self):
		return self.typeflag==DIRTYPE

	def isFile(self):
		return (self.typeflag==REGTYPE or
				self.typeflag==AREGTYPE)
	
	def getSize(self):
		return int(self.size, 8)

	def getMode(self):
		return int(self.mode, 8)

	def extractToFileSystem(self,prefix=''):
		nb = string.index(self.name, '\0')
		name = self.name[:nb]
		if self.isDirectory():
			try:
				os.mkdir(os.path.join(prefix,name), self.getMode())
			except OSError, (errn, msg):
				if errn != errno.EEXIST:
					raise error, (errn, msg)
			return
		if self.isFile():
			filename=os.path.join(prefix, name)
			# Joel Farr of LocalFS fame is responsible for this mess
			# I have no idea how he creates his tarballs
			dirname=os.path.dirname(filename)
			if not os.path.exists(dirname):
				try:
					os.mkdir(dirname, 0755)
				except:
					pass # something else will break anyway
			
			file = open(filename, "wb", self.getMode())
			file.write(self.data[:self.getSize()])
			file.close()
			return

	# Really basic, just for simple debug.
	def printHeader(self):
		print "Name:", self.name
		print "Size:", int(self.size, 8)
		print "Typeflag:", self.typeflag

	def read_tar_header(self):
		o = 0
		b=self.get_next_block()
		if not b:
			return
		self.name=b[o:o+100]
		o=o+100
		self.mode=b[o:o+8]
		o=o+8
		self.uid=b[o:o+8]
		o=o+8
		self.gid=b[o:o+8]
		o=o+8
		self.size=b[o:o+12]
		o=o+12
		self.mtime=b[o:o+12]
		o=o+12
		self.chksum=b[o:o+8]
		o=o+8
		self.typeflag=b[o]
		o=o+1
		self.linkname=b[o:o+100]
		o=o+100
		self.magic=b[o:o+6]
		o=o+6
		self.version=b[o:o+2]
		o=o+2
		self.uname=b[o:o+32]
		o=o+32
		self.gname=b[o:o+32]
		o=o+32
		self.devmajor=b[o:o+8]
		o=o+8
		self.devminor=b[o:o+8]
		o=o+8
		self.prefix=b[o:o+155]
		o=o+155
		return 1

	def getData(self):
		if self.typeflag==DIRTYPE:
			self.get_directory()
		if ( self.typeflag==REGTYPE or
			 self.typeflag==AREGTYPE):
			self.get_file()

	def get_directory(self):
		pass

	def get_file(self):
		blocks=0
		dotail=0
		sz = self.getSize()
		numBlocks=sz/TAR_BLOCKSIZE
		if sz % TAR_BLOCKSIZE:
			numBlocks=numBlocks+1
			
		while numBlocks:
			data = self.get_next_block()
			if data:
				self.data=self.data+data
				numBlocks=numBlocks-1
				blocks=blocks+1
			else:
				# Some kind of error...
				numBlocks=numBlocks-1
				blocks=blocks+1

	def processTarFile(self):
		pass

class TarHeader:
	name=''
	mode=''
	uid=''
	gid=''
	size=''
	mtime=''
	chksum=''
	typeflag=''
	linkname=''
	magic=''
	version=''
	uname=''
	gname=''
	devmajor=''
	devminor=''
	prefix=''
	gnu_longname=''
	gnu_longlink=''

class TarMemEntry(TarOps, TarHeader):
	eof=0
	def __init__(self, md):
		self.md=md
		if self.read_tar_header():
			self.getData()
		else:
			self.eof=1

	def get_next_block(self):
		b = self.md.read(TAR_BLOCKSIZE)
		if b[0]=='\0':
			self.eof=1
		return b

class TarGzFileEntry(TarOps, TarHeader):
	eof = 0
	def __init__(self, gzd):
		self.gzd=gzd
		if self.read_tar_header():
			self.getData()
		else:
			self.eof=1

	def get_next_block(self):
		b = self.gzd.read(TAR_BLOCKSIZE)
		if b[0] == '\0':
			self.eof = 1
			return None
		return b
	
class TarFileEntry(TarOps, TarHeader):
	eof=0
	def __init__(self, fd):
		self.fd=fd
		if self.read_tar_header():
			self.getData()
		else:
			self.eof=1

	def get_next_block(self):
		b = os.read(self.fd, TAR_BLOCKSIZE)
		if b[0]=='\0':
			self.eof=1
			return None
		return b

class MemoryPointer:
	def __init__(self, buffer):
		self.offset=0
		self.buffer=buffer
		self.size=len(buffer)

	def read(self,size):
		if self.offset+size < self.size:
			b=self.buffer[self.offset:self.offset+size]
			self.offset=self.offset+size
			return b
		elif self.offset < self.size:
			b = self.buffer[self.offset:]
			self.offset=self.size
			return b
		return ''

class TarInterface:
	def getEntry(self, entry):
		if entry < len(self.entries):
			return self.entries[entry]
		return None

	def getNumEntries(self):
		return len(self.entries)
	
class TarMem(TarInterface):
	def __init__(self, buffer):
		done = 0
		self.md = MemoryPointer(buffer)
		self.entries=[]
		while not done:
			entry = self.newTarEntry()
			if not entry.eof:
				self.entries.append(entry)
				entry.printHeader()
			else:
				done=1
				break

	def newTarEntry(self):
		return TarMemEntry(self.md)
			
		
class TarFile(TarInterface):
	def __init__(self, filename):
		done = 0
		file=open(filename, 'rb')
		self.fd = file.fileno()
		self.entries=[]
		while not done:
			entry = self.newTarEntry()
			if not entry.eof:
				self.entries.append(entry)
			else:
				done=1
				break

		file.close()

	def newTarEntry(self):
		return TarFileEntry(self.fd)

class TarGzFile(TarInterface):
	def __init__(self, filename):
		done = 0
		file = open(filename, 'rb')
		self.gzd = GzipFile(filename, 'rb', compresslevel=9, fileobj=file)
		self.entries=[]
		while not done:
			entry = self.newTarEntry()
			if not entry.eof:
				self.entries.append(entry)
			else:
				done =1
				break
		file.close()

	def newTarEntry(self):
		return TarGzFileEntry(self.gzd)
